/* $Id: namespace.h,v 1.3 2005/05/12 19:29:35 jwp Exp $
 *
 * Copyright 2005, PostgresPy Project.
 * http://python.projects.postgresql.org
 *
 *//*
 * Postgres namespace interface type
 */
#ifndef PyPg_namespace_H
#define PyPg_namespace_H 0
#ifdef __cplusplus
extern "C" {
#endif

typedef struct PyPgNamespace {
	PyPgObject_HEAD
} * PyPgNamespace;

extern PyTypeObject PyPgNamespace_Type;

#define PyPgNamespace_NEW()  \
	((PyObj) PyPgNamespace_Type.tp_alloc(&PyPgNamespace_Type, 0))

#define PyPgNamespace_Check(SELF) (PyObject_TypeCheck((SELF), &PyPgNamespace_Type))
#define PyPgNamespace_CheckExact(SELF) ((SELF)->ob_type == &PyPgNamespace_Type)

#define PyPgNamespace(SELF)	((PyPgNamespace) SELF)

#define PyPgNamespace_FetchStructure(SELF) \
	((Form_pg_namespace) PyPgObject_FetchStructure(SELF))

PyObj PyPgNamespace_FromOid(Oid);
PyObj pg_namespace_PyPgType(void);

#ifdef __cplusplus
}
#endif
#endif /* !PyPg_namespace_H */
/*
 * vim: ts=3:sw=3:noet:
 */
